
#include <buildboxcasd_requestmetadatamanager.h>
#include <buildboxcommon_requestmetadata.h>

using namespace buildboxcasd;
using namespace build::bazel::remote::execution::v2;

__thread RequestMetadata *RequestMetadataManager::d_request_metadata;

void RequestMetadataManager::setRequestMetadata(
    const RequestMetadata &metadata)
{
    if (d_request_metadata == nullptr) {
        d_request_metadata = new RequestMetadata();
    }
    d_request_metadata->CopyFrom(metadata);
    d_request_metadata->mutable_tool_details()->set_tool_name(
        d_request_metadata->tool_details().tool_name() +
        " (via buildbox-casd)");
}

RequestMetadata RequestMetadataManager::getRequestMetadata()
{
    return *d_request_metadata;
}

void RequestMetadataManager::attachMetadata(grpc::ClientContext *ctx)
{
    if (d_request_metadata != nullptr) {
        ctx->AddMetadata(
            buildboxcommon::RequestMetadataGenerator::HEADER_NAME,
            RequestMetadataManager::getRequestMetadata().SerializeAsString());
    }
}

void RequestMetadataManager::unsetRequestMetadata()
{
    if (d_request_metadata != nullptr) {
        delete d_request_metadata;
        d_request_metadata = nullptr;
    }
}
